;rotate tile test, for asm6

enum $000	;define some variables

temp1		.db 0
temp2		.db 0
temp3		.db 0
temp4		.db 0
temp5		.db 0
temp6		.db 0
temp7		.db 0
temp8		.db 0

nmi_flag	.db 0
rle_low		.db 0
rle_high	.db 0
rle_tag		.db 0
rle_byte	.db 0
soft2000		.db 0
soft2001		.db 0
scroll_x	.db 0
scroll_y	.db 0
framecount	.db 0

ende

sprite_buffer = $200	;sprites are at 200-2ff of ram

PAD_A = $01 ;copied from neslib
PAD_B = $02
PAD_SELECT = $04
PAD_START = $08
PAD_UP = $10
PAD_DOWN = $20
PAD_LEFT = $40
PAD_RIGHT = $80




.byte "NES",$1a 
.byte $02	;prg banks
.byte $00	;chr banks
.byte $01, $00
.byte $00,$00,$00,$00,$00,$00,$00,$00


    .org $8000    
Reset:
	sei				;turn off irqs
	cld
	ldx #$40
	stx $4017
	ldx #$ff
	txs				;reset stack position
	inx				;x = 0
	stx $2000		
	stx $2001		;turn off screen
	stx $4010
	lda $2002
	jsr Wait_Vblank
	jsr Wait_Vblank		;wait at least 2 v-blanks

	ldx #0
	txa
Blankram:
	sta $00, x
	sta $0100, x
	sta $0200, x
	sta $0300, x
	sta $0400, x
	sta $0500, x
	sta $0600, x
	sta $0700, x
	inx
	bne Blankram
	
MusicInit:		;just silences music
	lda #0
	sta $4015

	jsr Wait_Vblank ;double checking PPU is warmed up

	jsr Blanksprite
	jsr ClearNT

LoadPalette:
	lda $2002
	lda #$3f
	sta $2006
	lda #$00
	sta $2006
	ldx #8
PaletteLoop:
	lda #$0f
	sta $2007
	lda #$16
	sta $2007
	lda #$1a
	sta $2007
	lda #$30
	sta $2007
	dex
	bne PaletteLoop:
	
	

	lda #$20 ;draw 5 tiles on the screen
	sta $2006
	lda #$22
	sta $2006
	ldx #1
	stx $2007
	inx
	stx $2007
	inx
	stx $2007
	inx
	stx $2007
	inx
	stx $2007
	
	
	lda #0
	sta $2006
	lda #$00 ;0000 tile = blank
	sta $2006
	ldx #0
tile_loop:
	lda #0
	sta $2007
	inx
	cpx #$10
	bne tile_loop
	
	ldx #0
tile_loop2: ;0010 tile, copy tile from ROM
	lda ONE_TILE, x
	sta $2007
	inx
	cpx #$10
	bne tile_loop2
	
	jsr Rotate_Left ;0020 tile, rotate left
	lda #$00
	sta $2006
	lda #$20
	sta $2006
	jsr Push_300
	
	
	jsr Rotate_Right ;0030 tile, rotate right
	lda #$00
	sta $2006
	lda #$30
	sta $2006
	jsr Push_300
	
	jsr Flip_H ;0040 tile, flip H
	lda #$00
	sta $2006
	lda #$40
	sta $2006
	jsr Push_300
	
	jsr Flip_V ;0050 tile, flip V
	lda #$00
	sta $2006
	lda #$50
	sta $2006
	jsr Push_300
	

	lda #$00
	sta scroll_x
	sta scroll_y
	sta $2006
	sta $2006
	sta $2005
	sta $2005
	
	jsr Wait_Vblank
	
	lda #$88	;turn on nmi
	sta soft2000
	sta $2000
	lda #$1e
	sta soft2001 	;screen will turn on during first nmi

MainLoop:	;infinite loop
	jsr Wait_NMI
	inc framecount
	
	jmp MainLoop
	
	
	
Rotate_Left: ;2250 cycles, 20 lines
	ldy #0
	ldx #0
@Loop:
	lda ONE_TILE, Y
@Loop2:
	lsr a
	rol $0300, X
	inx
	cpx #8
	bne @Loop2
	ldx #0
	iny
	cpy #8
	bne @Loop
	
	ldx #8
;x and y should be 8 now
@Loop3:
	lda ONE_TILE, Y
@Loop4:
	lsr a
	rol $0300, X
	inx
	cpx #16
	bne @Loop4
	ldx #8
	iny
	cpy #16
	bne @Loop3
	rts
	
	
	
Rotate_Right: ;2250 cycles / 20 lines
	ldy #0
	ldx #0
@Loop5:
	lda ONE_TILE, Y
@Loop6:
	asl a
	ror $0300, X
	inx
	cpx #8
	bne @Loop6
	ldx #0
	iny
	cpy #8
	bne @Loop5
	
	ldx #8
;x and y should be 8 now
@Loop7:
	lda ONE_TILE, Y
@Loop8:
	asl a
	ror $0300, X
	inx
	cpx #16
	bne @Loop8
	ldx #8
	iny
	cpy #16
	bne @Loop7
	rts	
	

	
Push_300:
	ldx #0
@tile_loop3:
	lda $0300, x
	sta $2007
	inx
	cpx #$10
	bne @tile_loop3
	rts
	
	
	
Flip_H:
	ldx #0
	ldy #8
@Loop9:
	lda ONE_TILE, X
@Loop10:
	lsr a
	rol $0300, X
	dey
	bne @Loop10
	ldy #8
	inx
	cpx #16
	bne @Loop9
	rts
	
	
Flip_V:
	ldx #0
	ldy #7
@Loop11:
	lda ONE_TILE, X
	sta $0300, y
	dey
	inx
	cpx #8
	bne @Loop11
	
	ldx #8
	ldy #15
@Loop12:
	lda ONE_TILE, X
	sta $0300, y
	dey
	inx
	cpx #16
	bne @Loop12
	rts	
	
	
	
Wait_Vblank:
	lda $2002
	bpl Wait_Vblank
	rts
	
	

Wait_NMI:
	lda nmi_flag
@wait:
	cmp nmi_flag
	beq @wait
	rts
		
	
	
Blanksprite:
	ldx #$00
	lda #$ff	;y = ff, below bottom of screen
Blanksprite2:		;puts all sprites off screen
	sta sprite_buffer, x
	inx
	bne Blanksprite2
	rts
	


ClearNT:
	lda $2002
	lda #$20
	sta $2006
	lda #$00
	sta $2006
	lda #$00	;tile 0 is all black/blank
	ldy #$08
	ldx #$00
BlankName:		;blanks screen
	sta $2007
	dex
	bne BlankName
	dey
	bne BlankName
	rts


	



;x = high byte data
;a = low byte data
;make sure you set a PPU address first with 2 writes to 2006
UnRLE:
	tay
	stx <rle_high
	lda #0
	sta <rle_low

	lda (rle_low),y
	sta <rle_tag
	iny
	bne @1
	inc <rle_high
@1:
	lda (rle_low),y
	iny
	bne @11
	inc <rle_high
@11:
	cmp <rle_tag
	beq @2
	sta $2007
	sta <rle_byte
	bne @1
@2:
	lda (rle_low),y
	beq @4
	iny
	bne @21
	inc <rle_high
@21:
	tax
	lda <rle_byte
@3:
	sta $2007
	dex
	bne @3
	beq @1
@4:
	rts



	
NMI:
	pha
	txa
	pha
	tya
	pha
	inc nmi_flag
	
	lda #$00	;draw sprites
	sta $2003
	lda #>sprite_buffer
	sta $4014

	lda soft2000
	sta $2000
	lda soft2001
	sta $2001	
	lda scroll_x
	sta $2005
	lda scroll_y
	sta $2005
	
;	jsr FamiToneUpdate	
	
	pla
	tay
	pla
	tax
	pla
IRQ:
	rti








;BG_DATA:
;.incbin "sample.rle"

ONE_TILE:
.hex f8 0c 0c 38 0c 0c f8 c0
.hex f8 0c 0c 38 0c 0c 3b 03

	
    .org $FFFA
.word NMI, Reset, IRQ



;.incbin "Alpha.chr"
